DescriptorProtos.SourceCodeInfo.Location.Builder
Date: 2017-07-08

com.google.protobuf

## Class DescriptorProtos.SourceCodeInfo.Location.Builder

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite.Builder
  - - com.google.protobuf.AbstractMessage.Builder<BuilderType>
    - - com.google.protobuf.GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>
      - - com.google.protobuf.DescriptorProtos.SourceCodeInfo.Location.Builder

- All Implemented Interfaces:
    DescriptorProtos.SourceCodeInfo.LocationOrBuilder, Message.Builder, MessageLite.Builder, MessageLiteOrBuilder, MessageOrBuilder, java.lang.Cloneable
  Enclosing class:
    DescriptorProtos.SourceCodeInfo.Location

      public static final class DescriptorProtos.SourceCodeInfo.Location.Builder
      extends GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>
      implements DescriptorProtos.SourceCodeInfo.LocationOrBuilder

  Protobuf type `google.protobuf.SourceCodeInfo.Location`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addAllLeadingDetachedComments(java.lang.Iterable<java.lang.String> values)` `repeated string leading_detached_comments = 6;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addAllPath(java.lang.Iterable<? extends java.lang.Integer> values)` Identifies which part of the FileDescriptorProto was defined at this location.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addAllSpan(java.lang.Iterable<? extends java.lang.Integer> values)` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addLeadingDetachedComments(java.lang.String value)` `repeated string leading_detached_comments = 6;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addLeadingDetachedCommentsBytes(ByteString value)` `repeated string leading_detached_comments = 6;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addPath(int value)` Identifies which part of the FileDescriptorProto was defined at this location.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addRepeatedField(Descriptors.FieldDescriptor field, java.lang.Object value)` Like `setRepeatedField`, but appends the value as a new element.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `addSpan(int value)` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `DescriptorProtos.SourceCodeInfo.Location` | `build()` Constructs the message based on the state of the Builder.
    `DescriptorProtos.SourceCodeInfo.Location` | `buildPartial()` Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clear()` Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearField(Descriptors.FieldDescriptor field)` Clears the field.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearLeadingComments()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearLeadingDetachedComments()` `repeated string leading_detached_comments = 6;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearOneof(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearPath()` Identifies which part of the FileDescriptorProto was defined at this location.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearSpan()` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clearTrailingComments()` `optional string trailing_comments = 4;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `clone()` Clones the Builder.
    `DescriptorProtos.SourceCodeInfo.Location` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `static Descriptors.Descriptor` | `getDescriptor()`
    `Descriptors.Descriptor` | `getDescriptorForType()` Get the message's type's descriptor.
    `java.lang.String` | `getLeadingComments()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `ByteString` | `getLeadingCommentsBytes()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `java.lang.String` | `getLeadingDetachedComments(int index)` `repeated string leading_detached_comments = 6;`
    `ByteString` | `getLeadingDetachedCommentsBytes(int index)` `repeated string leading_detached_comments = 6;`
    `int` | `getLeadingDetachedCommentsCount()` `repeated string leading_detached_comments = 6;`
    `ProtocolStringList` | `getLeadingDetachedCommentsList()` `repeated string leading_detached_comments = 6;`
    `int` | `getPath(int index)` Identifies which part of the FileDescriptorProto was defined at this location.
    `int` | `getPathCount()` Identifies which part of the FileDescriptorProto was defined at this location.
    `java.util.List<java.lang.Integer>` | `getPathList()` Identifies which part of the FileDescriptorProto was defined at this location.
    `int` | `getSpan(int index)` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `int` | `getSpanCount()` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `java.util.List<java.lang.Integer>` | `getSpanList()` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `java.lang.String` | `getTrailingComments()` `optional string trailing_comments = 4;`
    `ByteString` | `getTrailingCommentsBytes()` `optional string trailing_comments = 4;`
    `boolean` | `hasLeadingComments()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `boolean` | `hasTrailingComments()` `optional string trailing_comments = 4;`
    `protected GeneratedMessageV3.FieldAccessorTable` | `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `mergeFrom(DescriptorProtos.SourceCodeInfo.Location other)`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `mergeFrom(Message other)` Merge `other` into the message being built.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `mergeUnknownFields(UnknownFieldSet unknownFields)` Merge some unknown fields into the `UnknownFieldSet` for this message.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setField(Descriptors.FieldDescriptor field, java.lang.Object value)` Sets a field to the given value.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setLeadingComments(java.lang.String value)` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setLeadingCommentsBytes(ByteString value)` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setLeadingDetachedComments(int index, java.lang.String value)` `repeated string leading_detached_comments = 6;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setPath(int index, int value)` Identifies which part of the FileDescriptorProto was defined at this location.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setRepeatedField(Descriptors.FieldDescriptor field, int index, java.lang.Object value)` Sets an element of a repeated field to the given value.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setSpan(int index, int value)` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setTrailingComments(java.lang.String value)` `optional string trailing_comments = 4;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setTrailingCommentsBytes(ByteString value)` `optional string trailing_comments = 4;`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `setUnknownFields(UnknownFieldSet unknownFields)` Set the `UnknownFieldSet` for this message.

    - ### Methods inherited from class com.google.protobuf.GeneratedMessageV3.Builder

      `getAllFields, getField, getFieldBuilder, getOneofFieldDescriptor, getParentForChildren, getRepeatedField, getRepeatedFieldBuilder, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, internalGetMutableMapField, isClean, markClean, newBuilderForField, onBuilt, onChanged, parseUnknownField`

    - ### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

      `findInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

      `addAll, mergeFrom, newUninitializedMessageException`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLite.Builder

      `mergeFrom`

- - ### Method Detail

    - #### getDescriptor

          public static final Descriptors.Descriptor getDescriptor()

    - #### internalGetFieldAccessorTable

          protected GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()

      Description copied from class: `GeneratedMessageV3.Builder`
      Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.
      Specified by:
        `internalGetFieldAccessorTable` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### clear

          public DescriptorProtos.SourceCodeInfo.Location.Builder clear()

      Description copied from class: `GeneratedMessageV3.Builder`
      Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
      Specified by:
        `clear` in interface `Message.Builder`
      Specified by:
        `clear` in interface `MessageLite.Builder`
      Overrides:
        `clear` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### getDescriptorForType

          public Descriptors.Descriptor getDescriptorForType()

      Description copied from interface: `Message.Builder`
      Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.
      Specified by:
        `getDescriptorForType` in interface `Message.Builder`
      Specified by:
        `getDescriptorForType` in interface `MessageOrBuilder`
      Overrides:
        `getDescriptorForType` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### getDefaultInstanceForType

          public DescriptorProtos.SourceCodeInfo.Location getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.
      Specified by:
        `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
      Specified by:
        `getDefaultInstanceForType` in interface `MessageOrBuilder`

    - #### build

          public DescriptorProtos.SourceCodeInfo.Location build()

      Description copied from interface: `MessageLite.Builder`
      Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.
      Specified by:
        `build` in interface `Message.Builder`
      Specified by:
        `build` in interface `MessageLite.Builder`

    - #### buildPartial

          public DescriptorProtos.SourceCodeInfo.Location buildPartial()

      Description copied from interface: `MessageLite.Builder`
      Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.
      Specified by:
        `buildPartial` in interface `Message.Builder`
      Specified by:
        `buildPartial` in interface `MessageLite.Builder`

    - #### clone

          public DescriptorProtos.SourceCodeInfo.Location.Builder clone()

      Description copied from interface: `MessageLite.Builder`
      Clones the Builder.
      Specified by:
        `clone` in interface `Message.Builder`
      Specified by:
        `clone` in interface `MessageLite.Builder`
      Overrides:
        `clone` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`
      See Also:
        `Object.clone()`

    - #### setField

          public DescriptorProtos.SourceCodeInfo.Location.Builder setField(Descriptors.FieldDescriptor field,
                                                                  java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Sets a field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` would return.
      Specified by:
        `setField` in interface `Message.Builder`
      Overrides:
        `setField` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### clearField

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearField(Descriptors.FieldDescriptor field)

      Description copied from interface: `Message.Builder`
      Clears the field. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the field.
      Specified by:
        `clearField` in interface `Message.Builder`
      Overrides:
        `clearField` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### clearOneof

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearOneof(Descriptors.OneofDescriptor oneof)

      Description copied from class: `AbstractMessage.Builder`
      TODO(jieluo): Clear it when all subclasses have implemented this method.
      Specified by:
        `clearOneof` in interface `Message.Builder`
      Overrides:
        `clearOneof` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### setRepeatedField

          public DescriptorProtos.SourceCodeInfo.Location.Builder setRepeatedField(Descriptors.FieldDescriptor field,
                                                                          int index,
                                                                          java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Sets an element of a repeated field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getRepeatedField(Descriptors.FieldDescriptor,int)` would return.
      Specified by:
        `setRepeatedField` in interface `Message.Builder`
      Overrides:
        `setRepeatedField` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### addRepeatedField

          public DescriptorProtos.SourceCodeInfo.Location.Builder addRepeatedField(Descriptors.FieldDescriptor field,
                                                                          java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Like `setRepeatedField`, but appends the value as a new element.
      Specified by:
        `addRepeatedField` in interface `Message.Builder`
      Overrides:
        `addRepeatedField` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### mergeFrom

          public DescriptorProtos.SourceCodeInfo.Location.Builder mergeFrom(Message other)

      Description copied from interface: `Message.Builder`
      Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`). Merging occurs as follows. For each field:
      * For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
      * For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
      * For repeated fields, the elements in `other` are concatenated with the elements in this message. * For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved. This is equivalent to the `Message::MergeFrom` method in C++.
      Specified by:
        `mergeFrom` in interface `Message.Builder`
      Overrides:
        `mergeFrom` in class `AbstractMessage.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### mergeFrom

          public DescriptorProtos.SourceCodeInfo.Location.Builder mergeFrom(DescriptorProtos.SourceCodeInfo.Location other)

    - #### isInitialized

          public final boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### mergeFrom

          public DescriptorProtos.SourceCodeInfo.Location.Builder mergeFrom(CodedInputStream input,
                                                                   ExtensionRegistryLite extensionRegistry)
                                                                     throws java.io.IOException

      Description copied from interface: `MessageLite.Builder`
      Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.
      Specified by:
        `mergeFrom` in interface `Message.Builder`
      Specified by:
        `mergeFrom` in interface `MessageLite.Builder`
      Overrides:
        `mergeFrom` in class `AbstractMessage.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`
      Throws:
        `java.io.IOException`

    - #### getPathList

          public java.util.List<java.lang.Integer> getPathList()

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPathList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getPathCount

          public int getPathCount()

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPathCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getPath

          public int getPath(int index)

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPath` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### setPath

          public DescriptorProtos.SourceCodeInfo.Location.Builder setPath(int index,
                                                                 int value)

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`

    - #### addPath

          public DescriptorProtos.SourceCodeInfo.Location.Builder addPath(int value)

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`

    - #### addAllPath

          public DescriptorProtos.SourceCodeInfo.Location.Builder addAllPath(java.lang.Iterable<? extends java.lang.Integer> values)

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`

    - #### clearPath

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearPath()

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`

    - #### getSpanList

          public java.util.List<java.lang.Integer> getSpanList()

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpanList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getSpanCount

          public int getSpanCount()

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpanCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getSpan

          public int getSpan(int index)

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpan` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### setSpan

          public DescriptorProtos.SourceCodeInfo.Location.Builder setSpan(int index,
                                                                 int value)

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`

    - #### addSpan

          public DescriptorProtos.SourceCodeInfo.Location.Builder addSpan(int value)

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`

    - #### addAllSpan

          public DescriptorProtos.SourceCodeInfo.Location.Builder addAllSpan(java.lang.Iterable<? extends java.lang.Integer> values)

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`

    - #### clearSpan

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearSpan()

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`

    - #### hasLeadingComments

          public boolean hasLeadingComments()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `hasLeadingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingComments

          public java.lang.String getLeadingComments()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `getLeadingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingCommentsBytes

          public ByteString getLeadingCommentsBytes()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `getLeadingCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### setLeadingComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder setLeadingComments(java.lang.String value)

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`

    - #### clearLeadingComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearLeadingComments()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`

    - #### setLeadingCommentsBytes

          public DescriptorProtos.SourceCodeInfo.Location.Builder setLeadingCommentsBytes(ByteString value)

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`

    - #### hasTrailingComments

          public boolean hasTrailingComments()

      `optional string trailing_comments = 4;`
      Specified by:
        `hasTrailingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getTrailingComments

          public java.lang.String getTrailingComments()

      `optional string trailing_comments = 4;`
      Specified by:
        `getTrailingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getTrailingCommentsBytes

          public ByteString getTrailingCommentsBytes()

      `optional string trailing_comments = 4;`
      Specified by:
        `getTrailingCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### setTrailingComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder setTrailingComments(java.lang.String value)

      `optional string trailing_comments = 4;`

    - #### clearTrailingComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearTrailingComments()

      `optional string trailing_comments = 4;`

    - #### setTrailingCommentsBytes

          public DescriptorProtos.SourceCodeInfo.Location.Builder setTrailingCommentsBytes(ByteString value)

      `optional string trailing_comments = 4;`

    - #### getLeadingDetachedCommentsList

          public ProtocolStringList getLeadingDetachedCommentsList()

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedCommentsCount

          public int getLeadingDetachedCommentsCount()

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedComments

          public java.lang.String getLeadingDetachedComments(int index)

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedCommentsBytes

          public ByteString getLeadingDetachedCommentsBytes(int index)

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### setLeadingDetachedComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder setLeadingDetachedComments(int index,
                                                                                    java.lang.String value)

      `repeated string leading_detached_comments = 6;`

    - #### addLeadingDetachedComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder addLeadingDetachedComments(java.lang.String value)

      `repeated string leading_detached_comments = 6;`

    - #### addAllLeadingDetachedComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder addAllLeadingDetachedComments(java.lang.Iterable<java.lang.String> values)

      `repeated string leading_detached_comments = 6;`

    - #### clearLeadingDetachedComments

          public DescriptorProtos.SourceCodeInfo.Location.Builder clearLeadingDetachedComments()

      `repeated string leading_detached_comments = 6;`

    - #### addLeadingDetachedCommentsBytes

          public DescriptorProtos.SourceCodeInfo.Location.Builder addLeadingDetachedCommentsBytes(ByteString value)

      `repeated string leading_detached_comments = 6;`

    - #### setUnknownFields

          public final DescriptorProtos.SourceCodeInfo.Location.Builder setUnknownFields(UnknownFieldSet unknownFields)

      Description copied from interface: `Message.Builder`
      Set the `UnknownFieldSet` for this message.
      Specified by:
        `setUnknownFields` in interface `Message.Builder`
      Overrides:
        `setUnknownFields` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`

    - #### mergeUnknownFields

          public final DescriptorProtos.SourceCodeInfo.Location.Builder mergeUnknownFields(UnknownFieldSet unknownFields)

      Description copied from interface: `Message.Builder`
      Merge some unknown fields into the `UnknownFieldSet` for this message.
      Specified by:
        `mergeUnknownFields` in interface `Message.Builder`
      Overrides:
        `mergeUnknownFields` in class `GeneratedMessageV3.Builder<DescriptorProtos.SourceCodeInfo.Location.Builder>`